package com.goafanti.common.dao;

import com.goafanti.common.model.LegalHolidays;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 法定节假日(LegalHolidays)表数据库访问层
 *
 * @author makejava
 * @since 2025-08-06 17:04:31
 */
public interface LegalHolidaysMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    LegalHolidays selectById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param legalHolidays 查询条件
     * @param pageable      分页对象
     * @return 对象列表
     */
    List<LegalHolidays> findLegalHolidaysList(LegalHolidays legalHolidays);

    /**
     * 统计总行数
     *
     * @param legalHolidays 查询条件
     * @return 总行数
     */
    int findLegalHolidaysCount(LegalHolidays legalHolidays);

    /**
     * 新增数据
     *
     * @param legalHolidays 实例对象
     * @return 影响行数
     */
    int insert(LegalHolidays legalHolidays);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<LegalHolidays> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<LegalHolidays> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<LegalHolidays> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<LegalHolidays> entities);

    /**
     * 修改数据
     *
     * @param legalHolidays 实例对象
     * @return 影响行数
     */
    int update(LegalHolidays legalHolidays);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<LegalHolidays> selectAll();
}

